#pragma once

#include <afxwin.h>         // MFC core and standard components
#include <stdio.h>

#include "MyCommandLine.h"

//#define FILENAME "NoteIt.ini"

// type => 0 bool, 1 string
struct stDesciption
{
	char szName[40];
	int type;
	bool bValue;
	char szData[40]; // password value etc
};

class cOptions
{
public:
	cOptions()
	{
		m_NumItems = 3;
	
		m_Data[0].type   = 0;
		m_Data[0].bValue = false;
		strcpy(m_Data[0].szData, "");
		strcpy(m_Data[0].szName, "password");
		
		m_Data[1].type   = 0;
		m_Data[1].bValue = false;
		strcpy(m_Data[1].szData, "");
		strcpy(m_Data[1].szName, "autostart");

		m_Data[2].type   = 1;
		m_Data[2].bValue = true;
		strcpy(m_Data[2].szData, "secret");
		strcpy(m_Data[2].szName, "paswdvalue");
	}
public:
	int m_NumItems;
	stDesciption m_Data[3];
};


class CMyData
{
public:
	char FILENAME[300];

	CMyData()
	{
		strcpy(FILENAME, "NoteIt.ini");

		HMODULE hInstance =  GetModuleHandle( 0 );
		
		char szFileName[300];
		GetModuleFileName(hInstance, szFileName,  300);

		int iLength = strlen(szFileName);
		for(int i=iLength;  i>0; i--)
		{
			if( szFileName[i] == '\\' )
				break;
			szFileName[i] = '\0';
		}
	
		strcat(szFileName, FILENAME);
		strcpy(FILENAME, szFileName);
	};
	~CMyData(){};


	cOptions m_Options;
protected:
	CEdit* m_pEdit;

public:

	CMyCommandLine m_MyCommandLine;
public:
	void SetData(CEdit* pEdit)
	{
		m_pEdit = pEdit;
	}
	
	void SaveData()
	{

		WriteOptions();

		FILE* fp = fopen(FILENAME, "a+");
		//fseek(fp, 0, SEEK_END);

		fputs("\n[DATA]\n", fp);

		char LargeBuffer[10000] = {'\0'};
		m_pEdit->GetWindowText(LargeBuffer, 10000);

		fwrite(LargeBuffer, 1, strlen(LargeBuffer), fp);

		fclose(fp);
	}


	void AddBoolValue(FILE* fp, char* str, bool value)
	{
		fputs(str, fp);
		fputs("=", fp);
		if( value == true )
			fputs("1", fp);
		else
			fputs("0", fp);
		
		fputs("\n", fp);

	}
	void AddStringValue(FILE* fp, char* str, char* value)
	{
		fputs(str, fp);
		fputs("=", fp);
		//fputs(value, fp);
		int length = 0;
		length = strlen(value);
		if(length)
		fwrite(value, 1, length, fp);
		
		fputc('\n', fp);
	}

	void WriteOptions()
	{

		FILE* fp = fopen(FILENAME, "w");

		fputs("[OPTIONS]\n", fp);
		for(int i=0; i< m_Options.m_NumItems; i++)
		{
			if(m_Options.m_Data[i].type == 0 ) // bool type.
				AddBoolValue(fp, m_Options.m_Data[i].szName, m_Options.m_Data[i].bValue);
			if(m_Options.m_Data[i].type == 1 ) // string type.
				AddStringValue(fp, m_Options.m_Data[i].szName, m_Options.m_Data[i].szData);
		}
		fputs("\n", fp);
		fclose(fp);
		
	}

	bool GetValue(char* str)
	{
		char* token = strtok( str, "=" );
		token = strtok( 0 , "=" );

		if( strstr(token, "1") != 0)
			return true;
		
		return false;
	}

	void GetStringValue(char* str, char* data)
	{
		memset(data, '\0', sizeof(data));
		char* token = strtok( str, "=" );
		token = strtok(NULL , "=" );
		
		if( (token == 0))
			strcpy(data, "");
		else
		{
			strncpy(data, token, strlen(token)-1);
			int len = 0;
			len = strlen(data)-1;
			if(len==0)
				data[len] = '\0';
		}

			
	}

	void ReadOptions()
	{

		char buf[10000] ;

		FILE* fp = fopen(FILENAME, "r");
		
		if(fp == 0)
			return;
		/*****Start reading options***********/
		memset(buf, '\0', sizeof(buf));
		while( fgets(buf, sizeof(buf), fp) )
		{
			if(feof(fp))
				break;
			if(ferror(fp))
				break;
			if(buf[0] == '\0')
				continue;
			if(buf[0] == '\n')
				continue;
			if(buf == 0)
				continue;

			if( strstr(buf, "[DATA]") != 0 )
				break;

			for(int i=0; i< m_Options.m_NumItems; i++ )
			{
				if( strstr(buf, m_Options.m_Data[i].szName) != 0 )
				{
					switch( m_Options.m_Data[i].type )
					{
					case 0:
						m_Options.m_Data[i].bValue = GetValue(buf);
						break;
					case 1:
						GetStringValue(buf, m_Options.m_Data[i].szData);
						break;
					default:
						;
					};//end switch
				}//end if
			}

			memset(buf, '\0', sizeof(buf));
		}
		/*****End reading options*************/
		fclose(fp);
	}

	void LoadData()
	{
		
		// Command Line Stuff!!!
		m_MyCommandLine.ParseCommands();
		
		m_Options.m_Data[0].bValue = m_MyCommandLine.b_p;

		ReadOptions();

		FILE* fp = fopen(FILENAME, "r");
		
		if(fp == 0)
			return;

		char LargeBuffer[10000] = {'\0'};
		
		while( fgets(LargeBuffer, sizeof(LargeBuffer), fp) )
			if( strstr(LargeBuffer, "[DATA]") != 0 )
				break;
			

		int iNumRead = fread(LargeBuffer, 1, sizeof(LargeBuffer), fp);
		
		memset(LargeBuffer+iNumRead, '\0', sizeof(LargeBuffer)-iNumRead);

		m_pEdit->SetWindowText(LargeBuffer);

		fclose(fp);



	}

	
};
