#pragma once

#include <afxwin.h>         // MFC core and standard components


#define UWM_CHECKTEXT WM_USER + 120
#define MY_VSCROLL    WM_USER + 121

#include "resource.h"

class CMyEdit : public CEdit
{
	//DECLARE_DYNAMIC(CMyEdit)
public:
	CMyEdit(void)
	{
		//CEdit::Create(ES_MULTILINE | WS_CHILD | WS_VISIBLE | ES_READONLY| WS_TABSTOP, 
		//	CRect(10,10,100,100), this, 108);
	};
	virtual ~CMyEdit(void){};
	
public:
	afx_msg void OnLButtonDown(UINT n, CPoint p)
	{
		CEdit::OnLButtonDown(n, p);
	}
public:
	afx_msg int OnCreate(LPCREATESTRUCT lp)
	{
		CEdit::OnCreate(lp);
		m_cr = RGB(255,0,0);
		m_Brush.CreateSolidBrush(m_cr);

		//m_MySBVert.Create(WS_VISIBLE|WS_CHILD|SBS_VERT, CRect(0,0,0,0), this, 0);
		//m_MySBHorz.Create(WS_VISIBLE|WS_CHILD|SBS_HORZ, CRect(0,0,0,0), this, 0);

		m_bHorz = false;
		m_bVert = true;

		return 1;
	}

	COLORREF m_cr;
	CBrush m_Brush;
	afx_msg HBRUSH CtlColor(CDC*pDC, UINT nCtlColor)
	{
		pDC->SetBkColor(m_cr);
		
		return m_Brush;
	}
	void SetBackColour(COLORREF cr)
	{
		m_Brush.DeleteObject();
		m_Brush.CreateSolidBrush(cr);
		m_cr = cr;
	}

/************************************************************************/
/*                                                                      */
/*      SCROLLBARS                                                      */
/*                                                                      */
/************************************************************************/
public:
	//CScrollBar m_MySBVert;
	//CScrollBar m_MySBHorz;

	bool m_bHorz;
	bool m_bVert;

	int m_iTextWidth;
	int m_iTextHeight;

	void SetWindowText(LPCTSTR lpszString)
	{
		CEdit::SetWindowText(lpszString);
		CheckScrolling(lpszString);
	}

	void CheckScrolling(LPCTSTR lpszString)
	{
		CRect oRect;
		GetClientRect(&oRect);
		CClientDC oDC(this);
		int iHeight = 0;
		BOOL bHoriz = FALSE;
		CFont* pEdtFont = CEdit::GetFont();
		
		TEXTMETRIC tm;
		GetTextMetrics(oDC.m_hDC, &tm);

		//~ if(pEdtFont != NULL)
		{
			

			//Determine Text Width and Height
			SIZE oSize;
		//~	CFont* pOldFont = oDC.SelectObject(pEdtFont);
			//Determine the line Height
			oSize = oDC.GetTextExtent(CString(_T(" ")));
			iHeight = oSize.cy;
			//Text Width
			int iWidth = 0, i=0;
			CString oStr;
			//Parse the string; the lines in a multiline Edit are
			//seperated bye "\r\n"
			while(TRUE == ::AfxExtractSubString(oStr, lpszString, i, _T('\n')))
			{
				if(FALSE == bHoriz)
				{
					int iLen = oStr.GetLength() - 1;
					if(iLen >= 0)
					{
						//Eliminate last '\r'
						if(_T('\r') == oStr.GetAt(iLen))
							oStr = oStr.Left(iLen);
						oSize = oDC.GetTextExtent(oStr);
						if(iWidth < oSize.cx)
							iWidth = oSize.cx;
						if(iWidth >= oRect.Width())
							bHoriz = TRUE;

						m_iTextWidth = iWidth;
					
					}
				}
				i++;
			}
			//~ oDC.SelectObject(pOldFont);
			//Text Height
			iHeight *= i;
			m_iTextHeight = i * (tm.tmHeight + tm.tmExternalLeading);
		}
		ShowHorizScrollBar(bHoriz);
		ShowVertScrollBar( iHeight >= oRect.Height());
    }
	
	void OnShowWindow(BOOL bShow, UINT nStatus)
	{
		GetParent()->PostMessage(UWM_CHECKTEXT);
		CEdit::OnShowWindow(bShow, nStatus);
	}

	void OnSize(UINT nType, int cx, int cy)
	{
		GetParent()->PostMessage(UWM_CHECKTEXT);
		CEdit::OnSize(nType, cx, cy);
	}
	
	HRESULT OnCheckText(WPARAM wParam, LPARAM lParam)
	{
		CString s;
		GetWindowText(s);
		CheckScrolling((LPCTSTR)s);
		
		return 0;
	}

	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
	{
		GetParent()->PostMessage(WM_HSCROLL, 99, 99);
		GetParent()->PostMessage(WM_VSCROLL, 99, 99);
		
		GetParent()->PostMessage(UWM_CHECKTEXT);

		if(! (GetKeyState(VK_CONTROL) < 0))
		   CEdit::OnChar(nChar, nRepCnt, nFlags);
		
	}

	afx_msg void OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
	{
		GetParent()->PostMessage(WM_HSCROLL, 99, 99);
		GetParent()->PostMessage(WM_VSCROLL, 99, 99);

		
		if (nChar == 'S' && GetKeyState(VK_CONTROL) < 0)
			GetParent()->GetParent()->PostMessage(WM_COMMAND, CM_SAVE, 0);
		else if (nChar == 'A' && GetKeyState(VK_CONTROL) < 0)
			GetParent()->GetParent()->PostMessage(WM_COMMAND, CM_ABOUT, 0);
		else if (nChar == 'O' && GetKeyState(VK_CONTROL) < 0)
			GetParent()->GetParent()->PostMessage(WM_COMMAND, CM_OPTIONS, 0);
		else
			CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
		
			
	}
	afx_msg void OnKeyUp( UINT nChar, UINT nRepCnt, UINT nFlags )
	{
		CEdit::OnKeyUp(nChar, nRepCnt, nFlags);
	}

	afx_msg void OnPaint()
	{
		CEdit::OnPaint();
	}
	
	

	void ShowHorizScrollBar(BOOL show)
	{
		if( show == TRUE)
		{
			m_bHorz = true;
			//ShowScrollBar(SB_HORZ, TRUE);
			//m_MySBHorz.ShowWindow(SW_SHOW);
			//PositionScrollBars();

		}
		else
		{
			m_bHorz = false;
			//ShowScrollBar(SB_HORZ, FALSE);
			//m_MySBHorz.ShowWindow(SW_HIDE);
		}
	}
	
	void ShowVertScrollBar( BOOL show)
	{
		if( show == TRUE)
		{
			m_bVert = true;
			//ShowScrollBar(SB_VERT, TRUE);
			

			//m_MySBVert.ShowWindow(SW_SHOW);
			//PositionScrollBars();
		}
		else
		{
			m_bVert = false;
			//ShowScrollBar(SB_VERT, FALSE);
			//m_MySBVert.ShowWindow(SW_HIDE);
		}
	}

	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
	{
		CEdit::OnVScroll(nSBCode, nPos, pScrollBar);
	}
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
	{
		CEdit::OnHScroll(nSBCode, nPos, pScrollBar);
	}


protected:
	DECLARE_MESSAGE_MAP()
};
