#pragma once

#include "MyEdit.h"

#define UWM_CHECKTEXT WM_USER + 120
#define MY_VSCROLL    WM_USER + 121

class CMyEditBox : public CWnd
{
public:
	CMyEdit     m_MyEdit;

	CScrollBar m_MySBVert;
	CScrollBar m_MySBHorz;

	CBrush      m_Brush;

public:
	afx_msg int OnCreate(LPCREATESTRUCT lp)
	{
		CRect r;
		GetClientRect(&r);

		m_MyEdit.Create(ES_MULTILINE|WS_CHILD|WS_VISIBLE|WS_TABSTOP|ES_AUTOVSCROLL|ES_AUTOHSCROLL,
			r, this, 505);
		m_MyEdit.SetBackColour(RGB(255,255,0));

		m_MySBVert.Create(WS_VISIBLE|WS_CHILD|SBS_VERT, CRect(0,0,0,0), this, 0);
		m_MySBHorz.Create(WS_VISIBLE|WS_CHILD|SBS_HORZ, CRect(0,0,0,0), this, 0);

		m_Brush.CreateSolidBrush(RGB(255,255,0));

		CWnd::OnCreate(lp);
		return 1;
	}

	virtual void SetWindowText(LPCTSTR lpszString)
	{
		m_MyEdit.SetWindowText(lpszString);
	}
	virtual void GetWindowText(CString &rString)
	{
		m_MyEdit.GetWindowText(rString);
	}

	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus)
	{
		SendMessage(UWM_CHECKTEXT);

		return CWnd::OnShowWindow(bShow, nStatus);
	}
	afx_msg void OnSize(UINT nType, int cx, int cy)
	{
		SendMessage(UWM_CHECKTEXT);

		OnVScroll(0, 0, 0);
	}

	void CheckScrollBars()
	{
		CRect cEditRect;
		GetClientRect(&cEditRect);
		
		if(m_MyEdit.m_bHorz == true)
		{
			m_MySBHorz.MoveWindow(cEditRect.left, cEditRect.bottom-10, cEditRect.Width()-10, 10);
			cEditRect.bottom -= 10;
			m_MySBHorz.ShowWindow(SW_SHOW);
		}
		else
		{
			m_MySBHorz.ShowWindow(SW_HIDE);
			m_MyEdit.SendMessage(WM_HSCROLL, (WPARAM)SB_PAGELEFT, 0);
		}


		if(m_MyEdit.m_bVert == true)
		{
			m_MySBVert.MoveWindow(cEditRect.right-10, cEditRect.top, 10, cEditRect.Height() );
			cEditRect.right -= 10;
			m_MySBVert.ShowWindow(SW_SHOW);
		}
		else
		{
			m_MySBVert.ShowWindow(SW_HIDE);
			m_MyEdit.SendMessage(WM_VSCROLL, (WPARAM)SB_PAGEUP, 0);
		}


		m_MyEdit.MoveWindow(&cEditRect);
	}

	HRESULT OnCheckText(WPARAM wParam, LPARAM lParam)
	{
		m_MyEdit.SendMessage(UWM_CHECKTEXT);

		CheckScrollBars();

		return 1;
	}

public:
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
	{
		
		if( nSBCode != 99)
			m_MyEdit.OnVScroll(nSBCode, nPos, pScrollBar);

		SCROLLINFO si;
		ZeroMemory(&si, sizeof(SCROLLINFO));
        si.cbSize = sizeof(SCROLLINFO);

		CPoint p = m_MyEdit.GetCaretPos();
		CRect r;  m_MyEdit.GetClientRect(&r);
		
		
		si.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
		si.nMin = 0;
		si.nMax = m_MyEdit.m_iTextHeight;
		si.nPage = r.Height();
		si.nPos =  p.y ;
		
		m_MySBVert.SetScrollInfo(&si);	
		
	}

	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
	{
		SCROLLINFO si;
		ZeroMemory(&si, sizeof(SCROLLINFO));
        si.cbSize = sizeof(SCROLLINFO);

		CPoint p = m_MyEdit.GetCaretPos();
		CRect r;  m_MyEdit.GetClientRect(&r);
		
		si.fMask = SIF_POS | SIF_RANGE | SIF_PAGE;
		si.nMin = 0;
		si.nMax = m_MyEdit.m_iTextWidth;
		si.nPage = r.Width();
		si.nPos = p.x;
		

		m_MySBHorz.SetScrollInfo(&si);

		if( nSBCode != 99)
			m_MyEdit.OnHScroll(nSBCode, nPos, pScrollBar);
	}

	afx_msg HBRUSH OnCtlColor( CDC*pDC, CWnd* pWnd, UINT nCtlColor )
	{
		if( nCtlColor == CTLCOLOR_SCROLLBAR)
		{
			return m_Brush;
		}

		return CWnd::OnCtlColor(pDC, pWnd, nCtlColor);
	}



public:
	CMyEditBox(void){};
	~CMyEditBox(void){};

protected:
	DECLARE_MESSAGE_MAP()
};
